data {
    int K;
    int ResNoise[K];
    int ResSignal[K];
}
transformed data {
    vector[K] a;
    for (k in 1:K) {
        a[k] = 1.0;
    }
}
parameters {
    real mu_s;
    real<lower = 0.0> sgm_s;
    simplex[K] preCs;
}
transformed parameters {
    real C[K-1];
    real v;
    vector[K] theta_n;  
    vector[K] theta_s;  
    v = 0.0;
    for (k in 1:(K-1)) {
        v = v + preCs[k];
        C[k] = -5 + v * 15.0;     //   -5 < C[k] < 10
    }
    theta_n[1] = normal_cdf(C[1], 0.0, 1.0);
    theta_s[1] = normal_cdf(C[1], mu_s, sgm_s);
    for (k in 2:(K-1)) {
        theta_n[k] = normal_cdf(C[k], 0.0, 1.0) - normal_cdf(C[k-1], 0.0, 1.0);
        theta_s[k] = normal_cdf(C[k], mu_s, sgm_s) - normal_cdf(C[k-1], mu_s, sgm_s);
    }
    theta_n[K] = 1.0 - normal_cdf(C[K-1], 0.0, 1.0);
    theta_s[K] = 1.0 - normal_cdf(C[K-1], mu_s, sgm_s);
}
model {
    preCs ~ dirichlet(a);
    mu_s ~ normal(0.0, 1000.0);
    sgm_s ~ exponential(0.001);
    ResNoise ~ multinomial(theta_n);
    ResSignal ~ multinomial(theta_s);
}
